//*************************************************************
//			 R[h̔FAwR[hł̏o
//				  uCharCodeTestv
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOPP^T
//@@@@@@@@@@ŏIXVFQOPP^T    [TN128/J118]
//*************************************************************
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import org.mozilla.universalchardet.UniversalDetector;


public class CharCodeTest extends JPanel implements ActionListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//------------------------------------------------------------------
	//
	public static void main(String[] args) {
		JFrame frame=new JFrame();
		frame.getContentPane().add(new CharCodeTest());
		frame.setTitle("CharCodeTest");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);	//E~ŏI
		frame.setSize(550,400);
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//------------------------------------------------------------------
	//
	File fileBefore;
	File fileAfter;
	//
	JTextField fieldBefore=new JTextField(10);
	JButton buttonBefore=new JButton("͌");
	JTextField fieldCode=new JTextField(7);
	JComboBox comboInput=new JComboBox(new String[]{"SHIFT-JIS","JIS","ISO-2022-JP","EUC-JP","UTF-8","UTF-16","UNICODE","JISAutoDetect"});
	JButton buttonInput=new JButton("");
	//
	JTextArea area=new JTextArea();
	//
	JTextField fieldAfter=new JTextField(10);
	JButton buttonAfter=new JButton("o͐");
	JComboBox comboOutput=new JComboBox(new String[]{"SHIFT-JIS","JIS","ISO-2022-JP","EUC-JP","UTF-8","UTF-16","UNICODE"});
	JButton buttonOutput=new JButton("o");
	//
	//------------------------------------------------------------------RXgN^
	//
	public CharCodeTest(){
		//
		fileBefore=fileAfter=null;
		//
		fieldBefore.setEditable(false);
		fieldCode.setEditable(false);
		fieldAfter.setEditable(false);
		//
		JPanel panelInput=new JPanel();
		panelInput.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),""));	//g
		panelInput.add(buttonBefore);
		panelInput.add(fieldBefore);
		panelInput.add(fieldCode);
		panelInput.add(new JLabel(" "));
		panelInput.add(comboInput);
		panelInput.add(buttonInput);
		//
		JPanel panelOutput=new JPanel();
		panelOutput.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(),"o"));	//g
		panelOutput.add(buttonAfter);
		panelOutput.add(fieldAfter);
		panelOutput.add(new JLabel(" "));
		panelOutput.add(comboOutput);
		panelOutput.add(buttonOutput);
		//
		setLayout(new BorderLayout());
		add(panelInput,BorderLayout.NORTH);
		add(area,BorderLayout.CENTER);
		add(panelOutput,BorderLayout.SOUTH);
		//
		buttonBefore.addActionListener(this);
		buttonInput.addActionListener(this);
		buttonAfter.addActionListener(this);
		buttonOutput.addActionListener(this);
	}
	//------------------------------------------------------------------Cxg
	//
	public void actionPerformed(ActionEvent e) {
		Object object=e.getSource();
		if(object==buttonBefore){					//eLXgt@Cw肵AR[h𒲂ׂēǂݍ
			//_CAO
			JFileChooser chooser=new JFileChooser(fileBefore);
			//
			if(chooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION){
				fileBefore=chooser.getSelectedFile();
				fieldBefore.setText(fileBefore.getName());
				//
				String code=checkCode();	//R[h擾
				if(code!=null){		//ꂽR[hœǂݍ
					fieldCode.setText(code);
					//
					readText(code);
				}else{				//G[
					fieldCode.setText("");
					area.setText("");
				}
			}
		}else if(object==buttonInput){			//R[hnčēǂݍ
			readText( (String)comboInput.getSelectedItem() );
		}else if(object==buttonAfter){			//o͐t@C擾
			//_CAO
			JFileChooser chooser=new JFileChooser(fileBefore);
			//
			if(chooser.showSaveDialog(this)==JFileChooser.APPROVE_OPTION){
				fileAfter=chooser.getSelectedFile();
				fieldAfter.setText(fileAfter.getName());
			}
		}else if(object==buttonOutput){			//R[hnĕۑ
			writeText( (String)comboOutput.getSelectedItem() );
		}
	}
	//------------------------------------------------------------------
	//w̕R[hœǂݍ
	private void readText(String code){
		//
		if(fileBefore==null){
			JOptionPane.showMessageDialog(this,"t@Cw","G[",JOptionPane.ERROR_MESSAGE);
			return;
		}
		//
		try{
			BufferedReader reader=new BufferedReader(new InputStreamReader(new FileInputStream(fileBefore),code));
			//
			String line;
			area.setText("");
			while((line=reader.readLine())!=null){
				area.append(line+"\n");				//sR[hFJavał\nɁiJtextAreaŉsƂȂ邩j
			}
			reader.close();
		}catch(FileNotFoundException fnfe){
			JOptionPane.showMessageDialog(this,fnfe.getMessage(),"G[",JOptionPane.ERROR_MESSAGE);
		}catch(UnsupportedEncodingException uee){
			JOptionPane.showMessageDialog(this,uee.getMessage(),"G[",JOptionPane.ERROR_MESSAGE);
		}catch(IOException ioe){
			JOptionPane.showMessageDialog(this,ioe.getMessage(),"G[",JOptionPane.ERROR_MESSAGE);
		}
	}
	//w̕R[hŏ
	private void writeText(String code){
		//
		if(fileAfter==null){
			JOptionPane.showMessageDialog(this,"t@Cw","G[",JOptionPane.ERROR_MESSAGE);
			return;
		}
		//
		try{
			String line=area.getText();
			line=line.replaceAll("\n", System.getProperty("line.separator"));	//sR[hFt@Cł̓j[őI񂾂́il̓VXếj
			//
			PrintWriter writer=new PrintWriter(new OutputStreamWriter(new FileOutputStream(fileAfter),code));
			writer.print(line);
			writer.close();
		}catch(FileNotFoundException fnfe){
			JOptionPane.showMessageDialog(this,fnfe.getMessage(),"G[",JOptionPane.ERROR_MESSAGE);
		}catch(UnsupportedEncodingException uee){
			JOptionPane.showMessageDialog(this,uee.getMessage(),"G[",JOptionPane.ERROR_MESSAGE);
		}
	}
	//R[hF
	private String checkCode(){
		//
		if(fileBefore==null){
			JOptionPane.showMessageDialog(this,"t@Cw","G[",JOptionPane.ERROR_MESSAGE);
			return null;
		}
		//
		try {
			UniversalDetector detector=new UniversalDetector(null);
			FileInputStream fis=new FileInputStream(fileBefore);
			//
			byte[] buf=new byte[4096];
			int nread;
			while((nread=fis.read(buf))>0 && !detector.isDone()){
				detector.handleData(buf, 0, nread);
			}
			detector.dataEnd();
			//
			String encoding=detector.getDetectedCharset();
			if(encoding==null){		//sȂiAt@xbĝ݂łjFuJISAutoDetectvg
				JOptionPane.showMessageDialog(this,"GR[fBOs\nJISAutoDetectgp","G[",JOptionPane.ERROR_MESSAGE);
				encoding="JISAutoDetect";
			}
			//
			detector.reset();
			//
			fis.close();
			//
			return encoding;		//R[hԂ
		} catch (FileNotFoundException fnfe) {
			JOptionPane.showMessageDialog(this,fnfe.getMessage(),"G[",JOptionPane.ERROR_MESSAGE);
			return null;			//G[ȂnullԂ
		} catch (IOException ioe) {
			JOptionPane.showMessageDialog(this,ioe.getMessage(),"G[",JOptionPane.ERROR_MESSAGE);
			return null;			//G[ȂnullԂ
		}
	}
}
